function Quality = ExamineDist(goal,Extremity,TrajFinale,distFinale)
% save test8
global affich
global viewAxis
Ax = Extremity(1); 
Ay = Extremity(2);
Bx = goal(1);
By = goal(2);

L= sqrt( (Bx-Ax)^2 + (By-Ay)^2 );

% Distance point - optimal trajectory
Cxy = [];
Pxy = [];
for i = 1:size(TrajFinale,2)  
    Cx = TrajFinale(1,i);
    Cy = TrajFinale(2,i);
%     plot(Cx,Cy,'k*','LineWidth',3);
    
    
    r = ((Ay-Cy)*(Ay-By)-(Ax-Cx)*(Bx-Ax)) ./ L.^2;
    Px = Ax + r*(Bx-Ax);
    Py = Ay + r*(By-Ay);
    
    Cxy = [Cxy [Cx; Cy]];    
%     plot([Cx Px],[Cy Py],'k*-','LineWidth',1)   
    Pxy = [Pxy [Px; Py]];
%     hold on
end


for i = 1:size(TrajFinale,2)
    if affich == 1
        plot([Cxy(1,i) ,Pxy(1,i)], [Cxy(2,i), Pxy(2,i)],'k*-','LineWidth',1)
        hold on
        plot([Bx Ax],[By Ay],'r*-','LineWidth',2)
    end
    Variance = Cxy - Pxy;
    Variance = sqrt(Variance(1,:).^2 + Variance(2,:).^2);
end


if affich == 1
    figure
    subplot(121)
    plot(Variance)
    hold on
    plot(mean(Variance)*ones(1,size(Variance,2)),'m-')
end

if affich == 1
    subplot(122)
end
% Total distance performed
DistTotalPerformedTmp = zeros(1,size(TrajFinale,2));
CxOrigin = TrajFinale(1,1);
CyOrigin = TrajFinale(2,1);
for i = 2:size(TrajFinale,2)
    CxDest = TrajFinale(1,i);
    CyDest = TrajFinale(2,i);
    DistTotalPerformedTmp(i) = dist([CxOrigin CyOrigin], [CxDest CyDest]);
    if affich == 1
        plot([CxOrigin CxDest], [CyOrigin CyDest],'k-')
        hold on
    end
    CxOrigin = CxDest;
    CyOrigin = CyDest;
end


DistTotalPerformed = sum(DistTotalPerformedTmp);

if affich == 1
    hold on
    plot([Bx Ax],[By Ay],'r*-','LineWidth',2)
end

% for i = 1:size(TrajFinale,2)
%     if affich == 1
%         plot([Cxy(1,i) ,Pxy(1,i)], [Cxy(2,i), Pxy(2,i)],'k*-','LineWidth',1)
%         hold on
%         plot([Bx Ax],[By Ay],'r*-','LineWidth',2)
%     end
%     Variance = Cxy - Pxy;
%     Variance = sqrt(Variance(1,:).^2 + Variance(2,:).^2);
% end


% Optimal distance
DistTotalOptimal = dist(Extremity,TrajFinale(:,end));
% DistRest = distF/DistTotalOptimal;
if affich == 1
    axis(viewAxis)
end



ExtraDist = (min(DistTotalOptimal,DistTotalPerformed) - max(DistTotalPerformed,DistTotalOptimal))/ DistTotalOptimal;
DistToReach = distFinale / DistTotalOptimal;

% More Quality is near Zero, more the reaching is well performed 
disp(['ExtraDist : ' num2str(ExtraDist.^2)])
disp(['DistToReach : ' num2str(DistToReach.^2)]);
Quality = sqrt(ExtraDist.^2 + DistToReach.^2);





