function evaluationPerformance
% evaluates the performance of the robot with an listEvalPoints given
% nbPartial experiences from listLearning

%% initialise variables
variablesGlobales
saggGlobal

evalPerf  = evaluation();
evalPerf.nbEvalPoints   = size(evalPerf.listEvalPoints,1);
evalPerf.nbListLearning = size(listLearning,1);
dNPartial      = round(nbListLearning/50);
evalPerf.nbPartial      = 1;
evalPerf.listDist       = [];
evalPerf.listDist2      = [];
epmem.treeDirect   = createTreeDirect(mapp);
epmem.treeInv      = createTreeInv(mapp);

%connVrep.urbiClient = connectToVrep(connVrep.ipAddress, connVrep.portUrbi, connVrep.instanceVrep, WIN_PATH);

%% for each chunk of memory, evaluate if they can reach the goals of
%% listEvalPoints
while evalPerf.nbPartial<nbListLearning - dNPartial
    
    %% reinitialise all the data structures with the partial memory
    addList     = listLearning(evalPerf.nbPartial:evalPerf.nbPartial+dNPartial,:);
    nbPartial   = evalPerf.nbPartial + dNPartial;
    listPartial = listLearning(1:evalPerf.nbPartial, :);
    %populate the trees with the listPartial
    point       = [addList(:,mapp.dimA+1:mapp.dimA+mapp.dimY)]
    point(:,end) = 100*ceil( point(:,end)-0.01 )
    vector1     = [addList(:,1:mapp.dimA) point ];
    vector2     = [point addList(:,1:mapp.dimA)];
    epmem.treeDirect  = AddVectorToTree(treeDirect, vector1);
    epmem.treeInv     = AddVectorToTree(treeInv, vector2);   
    sumDist     = 0;
    sumDist2    = 0;
    %% measure performance for each goali of listEvalPoints
    for i=1:evalPerf.nbEvalPoints
        goali       = [evalPerf.listEvalPoints(i,:) 0];
        gOutcome  = goali;
        % pour tester avec nearest neighbour
        neighbourParam    = nearestInv( epmem, goali, 1);
        dist2 = distSqrt(goali, neighbourParam(1,epmem.treeInv.dimInput));
        sumDist2     = sumDist2 + dist2;
        % les vrais resultats avec interpolation
        [dist pos param] = localModel(episodicMem, goali, rFish);
        %movParam    = interpolateParam( goali, treeDirect, treeInv, 6, NB_JOINTS, NB_CTR_POINTS);
        %[dist pos]  = experiment(movParam,3);
        sumDist     = sumDist + dist;
    end
    sumDist2 = sumDist2/evalPerf.nbEvalPoints;
    evalPerf.listDist2 =[evalPerf.listDist2; sumDist2];
    sumDist  = sumDist/evalPerf.nbEvalPoints;
    evalPerf.listDist =[evalPerf.listDist; sumDist];
    h2 = plot(evalPerf.listDist2,'b');
    hold on;
    h1 = plot(evalPerf.listDist,'r');
    hold on
    xlabel('timeline: assessment takes place every regular timestep');
    ylabel('mean distance to the goals');
    title('Benchmark : evaluation of the performance of the robot on the benchmark data');
    legend('assessment using the nearest neighbour', 'assessment using interpolation');

end

end

