function plotDataStats(filesDir)

%% ******     define the data types        ****** %%   

filenameROOT = {
   '../GoodData1110/RandomSmall/*Random*_Perf.mat';...
    '../GoodData1110/RiacSmall/RIAC3015_*_Perf.mat';...
    '../GoodData1110/Sgim11Small/*SGIM3015_35_25_15_*_nb_5001.mat';...
    '../GoodData1110/Sgim13Small/*SGIM3015_35_25_15_*_teacherid13_*_nb_5001.mat';...
    '../GoodData1110/Sgim21MaiSmall/*SGIM3015_35_25_15_*teacherid21_*_5001.mat';...
   '../GoodData1110/Observation11/Observation3015_35_25_15_*_teacherid11_*_nb_5001.mat';...
   '../GoodData1110/Observation13/Observation3015_35_25_15_*_teacherid13_*_nb_5001.mat';...
     '../GoodData1110/Observation21/Observation3015_35_25_15_*_nb_5001.mat';...
     '../GoodData1110/Imitation12Small/Imitation3015_35_25*teacherid12_*_instance1.mat';...
   '../GoodData1110/Imitation13/Imitation3015_35_25_15_*_teacherid13_*_nb_5001.mat';...
    '../GoodData1110/Imitation21MaiSmall/Imitation3015_35_25_15_*teacherid21_*_nb_5001.mat';...
   '../GoodData1110/RiacBig5020/RIACbig5020*_teacher*_nb_5001.mat';...
   '../GoodData1110/Sgim21MaiBig/*SGIMbig5020_35_25_15_*_teacherid21_*_nb_5001.mat';...
   '../GoodData1203/Sgimim21MaiSmall/*_SGIMIM_teacherid21_*2012_instance1.mat';...
   '../GoodData1203/Sgim21MaiSmall80/*_RIAC_teacherid21_teacherf*_instance1.mat';...
    };

folders = {
    '../GoodData1110/RandomSmall/';...
    '../GoodData1110/RiacSmall/';...
    '../GoodData1110/Sgim11Small/';...
    '../GoodData1110/Sgim13Small/';...
    '../GoodData1110/Sgim21MaiSmall/';...
   '../GoodData1110/Observation11/';...
   '../GoodData1110/Observation13/';...
     '../GoodData1110/Observation21/';...
     '../GoodData1110/Imitation12Small/';...
   '../GoodData1110/Imitation13/';...
    '../GoodData1110/Imitation21MaiSmall/';...
   '../GoodData1110/RiacBig5020/';...
   '../GoodData1110/Sgim21MaiBig/';...
   '../GoodData1203/Sgimim21MaiSmall/';...
   '../GoodData1203/Sgim21MaiSmall80/';...
    };

colors = [
    0 0 1  ;...
    0 1 0;
    1 0  0;
    0.9 0.3 0.1;
    0.5 0.5 0.5;
    0.5 0.5 0.7;
    0.9 0.1 0.3;
   0.9  0.1 0.8;
   0.9  0.1 0.8;
   0.1  0.1 0.8;
   0.1  0.5 0.8;
   0.2 0.8 0.1;
    0.8 0.4 0.4;
    1 0.0 0.0;
    0.5 0.9 0.9;
    ];

legends = {
    'RANDOM';...
    'RIAC';...
    'SGIM demonstrator = Auto RIAC';...
    'SGIM Imitation demonstrator = Var RIAC';...
    'SGIM (T=30)';... %demonstrator = Mai';...
    'Observation Auto RIAC';...
    'Observation Var RIAC';...
    'Observation Mai';...
    'Imitation Auto RIAC';...
    'Imitation Var RIAC';...
    'Imitation Mai';...
    'RIAC Big';...
    'SGIM big demonstrator = Mai';...
    'SGIMIM ' ;... %demonstrator = Mai';...
    'SGIM (T=80)'; ... % demonstrator = Mai';...
    };

lines = {
    '-d';...
    '-d';...
    '-o';...
    ':x';...
    '-o';...
    '-.o';...
    ':>';...
   '--d';...
   '--d';...
   '--d';...
    '--o';...
    '--x';...
    '-x';...
    '-s';...
    ':s';...
    };

%% ****** General variables ***  %%

[nbTypes ~] = size(filenameROOT)
[n1 ~]      = size(legends)
[n2 ~]      = size(folders)
size(colors,1)

if(nbTypes~= n1 || nbTypes~=n2 || nbTypes ~= size(colors,1))
    error('PLOTDATASTATS : error dimensions do not match');
end

%% ******     define the data files        ****** %%   
for iType =1: nbTypes
    filesList{iType} = dir(filenameROOT{iType,1} );
end

filesList
%% ******    record the data of each file     ******    %%
PLOT1 = 0

for iType =1: nbTypes % for each type of simu
    for indFile = 1:size(filesList{iType} ,1) % for each data file
        filename = [ folders{iType},filesList{iType}(indFile).name]
        load(filename);
        size(epmem.listLearning,1)
        listGoalSTAT(iType,indFile)     = {epmem.listGoal};
        listDist3STAT(iType,indFile)    = {evalPerf.listDist3(:,1)};
        listDist2STAT(iType,indFile)    = {evalPerf.listDist2(:,1)};
        listDistSTAT(iType,indFile)     = {evalPerf.listDist(:,1)};
        mapEvalSTAT(iType,indFile)      = {evalPerf.mapEval(:,:)};
        listLearningSTAT(iType,indFile) = {epmem.listLearning};
        if PLOT1
            figure('Name',filename,'NumberTitle','off')
            plotAll(filesList{iType}(indFile).name);
        end
    end
    
end

 

%% plot the goal density
nfiles = 4 %max([size(filesList{2},1) ; size(filesList{3},1)]); 
for iType =2: nbTypes % for each type of simu
    for indFile = 1:4 %size(filesList{iType} ,1) % for each data file
        filename = [ folders{iType},filesList{iType}(indFile).name]
        load(filename);
        Ymax =[ 2 2 100];
        subplot(nbTypes-1,nfiles,(iType-2)*nfiles+indFile);
        [F, xs, ys] = scattersmooth(epmem.listGoal(:,2), epmem.listGoal(:,3), 500, 1000,[-Ymax(1) Ymax(1)],[-Ymax(2) Ymax(2)]);
        imagesc(xs,ys,F);
        set(gca,'XTick',-2:1:2)
        set(gca,'YTick',-2:1:2)
        set(gca,'XTickLabel',{'-1';'-0.5';'0';'0.5';'1'})
        set(gca,'YTickLabel',{'-1';'-0.5';'0';'0.5';'1'})
    end
end



%% ******     plot the reached points     ******    %%
figReachedPoints = figure('Name','Reached Points','NumberTitle','off')
for iType = 1:nbTypes
    h{iType} = [];
end

for iType =1: nbTypes % for each type of simu
    for iFile = 1:size(filesList{iType} ,1) % for each data file
        ind = find(listLearningSTAT{iType,iFile}(:,mapp.dimA+3) <0.01);
        h{iType}= [h{iType}; plot(listLearningSTAT{iType,iFile}(ind,mapp.dimA+1), listLearningSTAT{iType,iFile}(ind,mapp.dimA+2), '.','Color',colors(iType,:),'MarkerSize',5)];
        hold on
    end
    pause
end

xlabel('x');
ylabel('y');
title('Reached Points  ');

for iType = 1:nbTypes
    hGroup{iType} = hggroup;
    set(h{iType},'Parent',hGroup{iType})
    set(get(get(hGroup{iType},'Annotation'),'LegendInformation'),'IconDisplayStyle','on');
    set(hGroup{iType}, 'Displayname', legends{iType});
end

legend('Location', 'northEast');
%legend('SAGG-RANDOM','SAGG-RIAC','SGIM','Random on the input parameters')

%% plot the convex hull of the reached points
%figure
for iType =1: nbTypes % for each type of simu
    x = [];
    y = [];
    for iFile = 1:size(filesList{iType} ,1) % for each data file
        ind = find(listLearningSTAT{iType,iFile}(:,mapp.dimA+3) <0.01);
        x = [x; listLearningSTAT{iType,iFile}(ind,mapp.dimA+1)];
        y = [y; listLearningSTAT{iType,iFile}(ind,mapp.dimA+2)];
    end
    k = convhull(x,y);
    h{iType} = plot(x(k),y(k),'-','Color',colors(iType,:))
    hold on
    set(h{iType}, 'Displayname', ['Convex hull of ',legends{iType}]);
    
end

xlabel('x');
ylabel('y');
title('Convex hull of the reached Points  ');
%set(h1, 'Displayname', 'Convex hull of SAGG RANDOM');
legend('Location', 'northEast');



%% ******     plot evaluation performance      ******    %%
figReachedPoints = figure('Name','Evaluation of the performance on the benchmark data','NumberTitle','off')
clear h1
clear h2
clear h3
for iType = 1:nbTypes
    h3{iType} = [];
    h1{iType} = [];
    h2{iType} = [];
    hGroup{iType} = hggroup;
    hGroup1{iType} = hggroup;
    hGroup2{iType} = hggroup;

end

for iType =[1: 11 13 14 15] % for each type of simu
    for iFile = 1:size(filesList{iType} ,1) % for each data file
        filename = [ folders{iType},filesList{iType}(iFile).name]
        hold on;
        h1{iType} = [h1{iType}; plot(mapEvalSTAT{iType,iFile}(:,end), listDist2STAT{iType,iFile},'--','Color',colors(iType,:))];
        hold on;
        h2{iType} = [h2{iType}; plot(mapEvalSTAT{iType,iFile}(:,end), listDistSTAT{iType,iFile},'-','Color',colors(iType,:))];
        ylim([0 1])
        hold on
       % pause
    end
end


ylim([0 1])
xlabel('Number of movements experimented');
ylabel('Mean distance to the goals');
title('Mean error on the benchmark data','FontSize',20,'FontWeight','b');

for iType = 1:nbTypes
    set(h3{iType},'Parent',hGroup{iType})
    set(h1{iType},'Parent',hGroup1{iType})
    set(h2{iType},'Parent',hGroup2{iType})
    set(get(get(hGroup{iType},'Annotation'),'LegendInformation'),'IconDisplayStyle','on');
    set(get(get(hGroup1{iType},'Annotation'),'LegendInformation'),'IconDisplayStyle','on');
    set(get(get(hGroup2{iType},'Annotation'),'LegendInformation'),'IconDisplayStyle','on');
    set(hGroup{iType}, 'Displayname', [legends{iType},' reexecute nearest neighbour']);
    set(hGroup1{iType}, 'Displayname', [legends{iType},' nearest neighbour']);
    set(hGroup2{iType}, 'Displayname', [legends{iType},' interpolation']);

end
hleg1= legend('Location', 'northEast');
set( hleg1, 'FontWeight','b')
set(hleg1,'FontName','FixedWidth')
        



%% ********** plot mean evaluation performance      ***************** %%
 for iType = [1 2 5 14 15] % for each type of simu
%for iType = 1:nbTypes  % for each type of simu
    meanMapEvalSTAT{iType}   = [];
    meanListDistSTAT{iType}  = [];
    meanListDist2STAT{iType} = [];
    meanListDist3STAT{iType} = [];
    namx = size(mapEvalSTAT{iType,3},1); 
% bug
    if iType == 15
    namx = 7;
end
    for iFile = 1:size(filesList{iType} ,1) % for each data file
        filename = [ folders{iType},filesList{iType}(iFile).name]
        size(mapEvalSTAT{iType,iFile})
        meanMapEvalSTAT{iType}   = [meanMapEvalSTAT{iType} mapEvalSTAT{iType,iFile}(1:namx,end)];
        meanListDistSTAT{iType} = [meanListDistSTAT{iType} listDistSTAT{iType,iFile}(1:namx,:)];
        meanListDist2STAT{iType} = [meanListDist2STAT{iType} listDist2STAT{iType,iFile}(1:namx,:)];
        meanListDist3STAT{iType} = [meanListDist3STAT{iType} listDist3STAT{iType,iFile}(1:namx,:)];
    end
    
    varListDistSTAT{iType}    = std(meanListDistSTAT{iType}',1)';
    varListDist2STAT{iType}   = std(meanListDist2STAT{iType}',1)';
    varListDist3STAT{iType}   = std(meanListDist3STAT{iType}',1)';
    meanMapEvalSTAT{iType}    = mean(meanMapEvalSTAT{iType},2);
    meanListDistSTAT{iType}   = mean(meanListDistSTAT{iType},2);
    meanListDist2STAT{iType}  = mean(meanListDist2STAT{iType},2);
    meanListDist3STAT{iType}  = mean(meanListDist3STAT{iType},2);
    errorbar(meanMapEvalSTAT{iType} ,meanListDistSTAT{iType},varListDistSTAT{iType}, '-d','Color',colors(iType,:), 'LineWidth',3)
    hold on
  %  errorbar(meanMapEvalSTAT{iType} ,meanListDist2STAT{iType},varListDist2STAT{iType}, ':d','Color',colors(iType,:), 'LineWidth',3)
    hold on
   % errorbar(meanMapEvalSTAT{iType} ,meanListDist3STAT{iType}, varListDist3STAT{iType}, '--d','Color',colors(iType,:), 'LineWidth',3)
    hold on
end


% % for Observation. (unsolved)
% for iType = 6
%     meanMapEvalSTAT{iType}   = [];
%     meanListDistSTAT{iType}  = [];
%     meanListDist2STAT{iType} = [];
%     meanListDist3STAT{iType} = [];
%     namx = size(mapEvalSTAT{iType,1},1); 
% 
%     for iFile = 1:size(filesList{iType} ,1) % for each data file
%         filename = [ folders{iType},filesList{iType}(iFile).name]
%         size(mapEvalSTAT{iType,iFile})
%         meanMapEvalSTAT{iType}   = [meanMapEvalSTAT{iType} mapEvalSTAT{iType,iFile}(1:namx,end)];
%         meanListDistSTAT{iType} = [meanListDistSTAT{iType} mean(mapEvalSTAT{iType,iFile}(1:namx,1:end-1),2) ];
%         meanListDist2STAT{iType} = [meanListDist2STAT{iType} listDist2STAT{iType,iFile}(1:namx,:)];
%         meanListDist3STAT{iType} = [meanListDist3STAT{iType} listDist3STAT{iType,iFile}(1:namx,:)];
%     end
%     
%     varListDistSTAT{iType}    = std(meanListDistSTAT{iType}',1)';
%     varListDist2STAT{iType}   = std(meanListDist2STAT{iType}',1)';
%     varListDist3STAT{iType}   = std(meanListDist3STAT{iType}',1)';
%     meanMapEvalSTAT{iType}    = mean(meanMapEvalSTAT{iType},2);
%     meanListDistSTAT{iType}   = mean(meanListDistSTAT{iType},2);
%     meanListDist2STAT{iType}  = mean(meanListDist2STAT{iType},2);
%     meanListDist3STAT{iType}  = mean(meanListDist3STAT{iType},2);
%     errorbar(meanMapEvalSTAT{iType} ,meanListDistSTAT{iType},varListDistSTAT{iType}, '-d','Color',colors(iType,:), 'LineWidth',3)
%     hold on
%   %  errorbar(meanMapEvalSTAT{iType} ,meanListDist2STAT{iType},varListDist2STAT{iType}, ':d','Color',colors(iType,:), 'LineWidth',3)
%     hold on
%    % errorbar(meanMapEvalSTAT{iType} ,meanListDist3STAT{iType}, varListDist3STAT{iType}, '--d','Color',colors(iType,:), 'LineWidth',3)
%     hold on
% end


%% interpolation mean only
figureMean = figure('XVisual',...
    '0x24 (TrueColor,depth 24, RGB mask 0xff0000 0xff00 0x00ff)',...
    'Name','Mean Values of the  Performance Evaluation on the Benchmark Data');
% Create axes
axes1 = axes('Parent',figureMean,'YGrid','on',...
    'XTick',[0 1000 2000 3000 4000 5000],...
    'FontWeight','bold',...
    'LineWidth',3,...
    'FontSize',14,...
    'FontName','Arial');
box(axes1,'on');
hold(axes1,'all');
 xlim(axes1,[0 5020]);
 ylim(axes1,[0.05 0.5]);
 
  for iType = [1 2 5 14 15]
%for iType = 1:14 %nbTypes  % for each type of simu
    h11{iType} =    errorbar(meanMapEvalSTAT{iType} ,meanListDistSTAT{iType}/2,varListDistSTAT{iType}/2, lines{iType},'Color',colors(iType,:), 'LineWidth',8,'MarkerSize',10)
    hold on
    set(h11{iType}, 'Displayname', legends{iType});
end




% Create title

title('Mean Values of the  Performance Evaluation on the Benchmark Data',...
    'FontSize',14,...
    'FontName','Arial Black');

% Create xlabel
xlabel('Number of Movements Experimented','FontWeight','bold','FontSize',14,...
    'FontName','Arial');

% Create ylabel
ylabel('Mean Distance to the Goals','FontWeight','bold','FontSize',14,...
    'FontName','Arial');

hleg1= legend('Location', 'northEast');
set( hleg1, 'FontWeight','b');
set(hleg1,'FontSize',14)
set(hleg1,'FontName','FixedWidth')
set(gca,'YGrid','on')
%axis([0 5020 0.1 0.7])


%% error wrt to #teachings

for iType = [5 14 15]
%for iType =1: nbTypes % for each type of simu
        if(isempty(findstr(legends{iType},'RANDOM')) && isempty(findstr(legends{iType},'RIAC')))
%     figure('Name',legends{iType},'NumberTitle','off')
iType
teachNb{iType} = [];
teachErr{iType} = [];

    for indFile = 1:size(filesList{iType} ,1) % for each data file
        filename = [ folders{iType},filesList{iType}(indFile).name]
        load(filename);
        size(epmem.listLearning,1)
        teachErr{iType}      = [teachErr{iType}; evalPerf.listDist(:,1)];
        timestamp     = evalPerf.mapEval(:,end);
        for i =1:length(timestamp)
           timestampTeach = find(hTeacher.listTeacher(:,1)<timestamp(i));
           teachNb{iType} = [teachNb{iType}; length(timestampTeach)+1];
        end
       
    end
    end
    
end


% regression
figureTeach = figure('XVisual',...
    '0x24 (TrueColor,depth 24, RGB mask 0xff0000 0xff00 0x00ff)',...
    'Name','Mean Error with respect to the Number of Demonstrations Given');
axesT = axes('Parent',figureTeach,...
    'FontWeight','bold',...
    'LineWidth',3,...
    'FontSize',14,...
    'FontName','Arial');
box(axesT,'on');
hold(axesT,'all');
iTeach = [0:5:100]';

for iType = [5 14 15]
%for iType =1: nbTypes % for each type of simu
    X =[];
    ia =[];
    ic =[];
    y =[];
        if(isempty(findstr(legends{iType},'RANDOM')) && isempty(findstr(legends{iType},'RIAC')))

   [X, ia, ic]  = unique(teachNb{iType}) ; %[ones(size(teachNb{iType})),  teachNb{iType} , teachNb{iType}.^2] ;%, teachNb{iType}.^3 ];
   for i =1:length(X)
       indNb = find(ic == i);
       y(i)  = mean([teachErr{iType}(indNb)]);
   end
   yinterp{iType} = interp1(X, y ,iTeach,'linear'); 
   % theta{iType} = pinv(X'*X)*X'*y;

% plot regression
  hr{iType} =   plot( iTeach, yinterp{iType},'Color',colors(iType,:),'LineWidth',8);

 % hr{iType} =   plot(X,y, 'o', iTeach, yinterp{iType},'Color',colors(iType,:),'LineWidth',8);
 hold on
    set(hr{iType}, 'Displayname', legends{iType});
    hold on
        end
end
xlim([min(iTeach) max(iTeach)])
title('Mean Error with respect to the Number of Demonstrations Given',...
    'FontSize',14,...
    'FontName','Arial Black');

% Create xlabel
xlabel('Number of Demonstrations Given','FontWeight','bold','FontSize',14,...
    'FontName','Arial');

% Create ylabel
ylabel('Mean Distance to the Goals','FontWeight','bold','FontSize',14,...
    'FontName','Arial');

hleg1= legend('Location', 'northEast');
set( hleg1, 'FontWeight','b');
set(hleg1,'FontSize',14)
set(hleg1,'FontName','FixedWidth')
set(gca,'YGrid','on')

%% plot percentage mode
iType = 14;
nh= 100;
s = zeros(2,4550);
                 cstring='grbcmyk';
                 for indFile = 1:size(filesList{iType} ,1)
                 for i= 1:4500 -nh
                     % autonomous learning 
                     s(1,i) = s(1,i) +length(find(listLearningSTAT{iType,indFile}(i:i+ ...
                         nh,end)==1)) + ...
                     length(find(listLearningSTAT{iType,indFile}(i:i+ ...
                                                               nh,end)==2));
                     % social learning 
                     s(2,i) =  s(2,i) + length(find(listLearningSTAT{iType,indFile}(i:i+ ...
                                                               nh,end)==0));
                 end
                 end
          
                 
                 figureStrategy = figure('XVisual',...
    '0x24 (TrueColor,depth 24, RGB mask 0xff0000 0xff00 0x00ff)',...
    'Name','Mean Values of the  Performance Evaluation on the Benchmark Data');
% Create axes
axes1 = axes('Parent',figureStrategy,'YGrid','on',...
    'XTick',[0 1000 2000 3000 4000 5000],...
    'FontWeight','bold',...
    'LineWidth',3,...
    'FontSize',14,...
    'FontName','Arial');
box(axes1,'on');
hold(axes1,'all');

 
                 %for imode = 1:length(modesL)
                 haut = plot(s(1,:)/(nh*indFile),cstring(1),'LineWidth',8)
                 hold on
                 set(haut, 'Displayname', 'Intrinsic Motivation Strategy');
                 hold on
                 hsoc = plot(s(2,:)/(nh*indFile),cstring(2),'LineWidth',8)
                 hold on
                 set(hsoc, 'Displayname', 'Social Learning Strategy');
                 hold on
                 %end
                 title(['intrinsic motivation strategy = ' cstring(1) ',  social learning strategy = ' cstring(2)]);   
                
 xlim(axes1,[0 length(s)-2*nh]);
ylim([0 1])
%% correlation and p-value computation
X = [];
for iType = [ 1 2 3] % for each type of simu: random, riac and sgim
    for indFile = 1:size(filesList{iType} ,1)
        observation = listDistSTAT{iType,indFile};
        whos observation
        observation = observation(end-5:end);
        X =[X observation(:)];
    end
end
[r,p] = corrcoef(X)
[RejectNullHypothesisi,RejectNullHypothesisj] = find(p<0.05);
[RejectNullHypothesisi,RejectNullHypothesisj]

RejectNullHypothesis = zeros(3,3);
disp('gather by type')
for ii = 1:size(RejectNullHypothesisi,1)
    i = RejectNullHypothesisi(ii)
    j = RejectNullHypothesisj(ii)
    disp(['i = ',num2str(i),', j= ', num2str(j)])
    iType = 0;
    while i>0
        iType = iType +1;
        i = i-size(filesList{iType} ,1);
    end
    jType = 0;
    while j>0
        jType = jType +1;
        j = j-size(filesList{jType} ,1);
    end
    iType 
    jType
   RejectNullHypothesis(iType,jType) =  RejectNullHypothesis(iType,jType) + 1;
end
end